<?php

    /*
     * Plugin Name: In8Sync Customers
     * Description: This plugin manages customer syncing with NetSuite
     * Version: 3.3.0
     * Author: In8Sync
     * Author URI: http://www.in8sync.com
     */

    /**
     * This is main plugin file which handles plugin installation and removal.
     * It includes required plugin files.
     */
    if (!defined('ABSPATH')) {
        exit; // Exit if accessed directly
    }

//debugging function
    if (!function_exists('in8Pr')) {

        function in8Pr($data) {
            echo "<pre>";
            print_r($data);
            echo "</pre>";
        }

    }

    register_activation_hook(__FILE__, 'in8_customer_activation');

    function in8_customer_activation() {
        //check if in8sync plugin is installed and activated
        if (!in_array('in8sync/in8sync.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            //deactivate plugin if parent in8sync is not activated
            deactivate_plugins(__FILE__);
            echo '<div id="error" class="error notice is-dismissible"><p>Plugin can\'t be activated.Please install main in8 plugin before activating.</div>';
            die;
        }
    }

//plugins load hook
    add_action('plugins_loaded', 'init_in8_customers_sync_plugin', 20);

//intialization function 
    function init_in8_customers_sync_plugin() {
        //check if in8sync plugin is installed and activated
        if (in_array('in8sync/in8sync.php', apply_filters('active_plugins', get_option('active_plugins')))) {
            define('In8_Customers_URL', plugin_dir_url(__FILE__));
            define('In8_Customers_PATH', plugin_dir_path(__FILE__));


            //check if membership plugin is enabled
            if (in_array('woocommerce-memberships/woocommerce-memberships.php', apply_filters('active_plugins', get_option('active_plugins')))) {
                define('MEMBERSHIP_PLUGIN_ENABLED', 1);
            }

            //admin setting tabs for customers and sale orders
            require_once('inc/options.php'); //customer settings option tab
            require_once('inc/customers.php'); //customer settings option tab
            require_once('inc/helper.php'); //helper function
            require_once('inc/user-profile.php'); //helper function
        } else {
            include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
            //deactivate plugin if parent in8sync is not activated
            deactivate_plugins(__FILE__);
        }
    }

//    add_action('admin_init', 'in8_activate_updates_customers');

    function in8_activate_updates_customers() {
        require_once (IN8_MAIN_DIR . '/code/in8-update.php');
        $plugin_data = get_plugin_data(__FILE__);
        if (isset($plugin_data['Version'])) {
            $plugin_current_version = $plugin_data['Version'];
        } else {
            $plugin_current_version = '2.0.1';
        }
        $plugin_remote_path = 'https://secure.in8sync.com/update/currentversion.php';
        $plugin_slug = plugin_basename(__FILE__);
        new in8_wp_auto_update($plugin_current_version, $plugin_remote_path, $plugin_slug);
    }
    