(function ($) {

    $(document).on('click', ".not_empty_check", function () {
        if ($(this).is(":checked")) {
            $(this).parent().next('td').find('input.input-sm').prop("disabled", true);
        } else {
            $(this).parent().next('td').find('input.input-sm').prop("disabled", false);

        }
    });

    $('.enable_vendors').on("click", function () {
        if ($(this).is(":checked")) {
            $(this).parent().find(".hidden_input").show();
        } else {
            $(this).parent().find(".hidden_input").hide();
        }
    });

    $('.enable_customer_plus_vendors').on("click", function () {
        if ($(this).is(":checked")) {
            $(this).parent().find(".hidden_input").show();
            $(".all_customer_as_vendor").attr('checked', false);
        } else {
            $(this).parent().find(".hidden_input").hide();
        }
    });

    $('.all_customer_as_vendor').on("click", function () {
        $(".enable_customer_plus_vendors").attr('checked', false);
        $(".enable_customer_plus_vendors").parent().find('.hidden_input').hide();
        $(".identify_user_type_custom_field,.identify_customer_custom_field_value,.identify_vendor_custom_field_value").val('');
    });

    //enabled/disable select box based on credit card enable checkbox
    $("#enable_credit_card").on('click', function () {
        if (document.getElementById('enable_credit_card').checked) {
            $("#in8_select_payment_gateway").attr("disabled", false);
        } else {
            $("#in8_select_payment_gateway").attr("disabled", true);
        }
    });

    $(document).on('click', ".removeRow", function () {
        $(this).parent().parent().remove();
    });

    $(document).on('click', "#addMoreCustomerMapingRows", function () {
        var num_rows = parseInt(jQuery('#netsuite_customer_mapping tbody tr:last').attr('id'));
        var row_index = num_rows + 1;
        var html = '<tr id="' + row_index + '"><td><input class="form-control input-sm" name="mapping_key[]"></td><td><input class="form-control input-sm" name="mapping_value[]"></td><td></td><td><input type="checkbox" name="mapping_update[' + num_rows + ']" class="form-control"></td><td><span class="btn btn-danger removeRow">X</span></td></tr>';
        $('#netsuite_customer_mapping tbody').append(html);
    });

    $(document).on('change', ".cm_customer_operator", function () {
        var cm_operator = $(this).val();
        if (cm_operator != 0) {
            var this_table = $(this).closest('table');
            var cm_box_index = this_table.parent().data('index');
            if (cm_operator == 2) {
                this_table.find('tbody tr').eq(0).find('td:gt(0)').remove();
                processCustomerCM(1, 2, this_table);
            } else if (cm_operator == 1 || cm_operator == 3 || cm_operator == 4) {
                this_table.find('tbody tr:gt(0)').remove();
                getCustomerTypeDropdown(this_table, cm_box_index);
            }
        }
    });

    $(document).on('change', ".cm_customer_type", function () {
        var cm_type = $(this).val();
        if (cm_type != 0) {
            var cm_operator = $(this).closest('td').prev('td').find('.cm_customer_operator').val();
            if (cm_operator != 0) {
                var this_table = $(this).closest('table');
                processCustomerCM(cm_type, cm_operator, this_table);
            }
        }
    });

    $(document).on('click', ".removeCustomerCMRow", function () {
        if (confirm("This action can't be undone")) {
            //truncating first row instead of removing
            if ($('.netsuite_customers_conditional_mapping').length == 1) {

                //reset input and select
                $('.netsuite_customers_conditional_mapping').find('select.cm_customer_type').remove();

                $('.netsuite_customers_conditional_mapping tbody tr:gt(0)').remove();

                $('.netsuite_customers_conditional_mapping tbody tr td').eq(1).empty();

                $('.netsuite_customers_conditional_mapping').find('select.cm_customer_operator').each(function () {
                    $(this).val(0);
                });
            } else {
                $(this).parent().remove();
            }
        }
    });

    $(document).on('click', "#addMoreCustomerConditionalMappingRows", function () {

        var clone_this = $(this).prev('div'); //get prev table to clone

        var current_index = clone_this[0].dataset.index; //get current index
        var next = parseInt(current_index) + 1; //increment table index   

        clone_this[0].dataset.index = next; //increment table index
        clone_this.find('tbody .cm_customer_operator').attr('name', 'cm[' + next + '][operator]');
        $(this).before(clone_this.clone()); // add new mapping row by cloing prev table

        clone_this[0].dataset.index = current_index; //fix for prev table
        clone_this.find('tbody .cm_customer_operator').attr('name', 'cm[' + current_index + '][operator]');

        //reset input and select
        $('.netsuite_customers_conditional_mapping:last tbody tr:gt(0)').remove();

        $('.netsuite_customers_conditional_mapping:last tbody tr').eq(0).find('td').eq(1).empty();

        if ($('.netsuite_customers_conditional_mapping:last').prev('.requiredCM').length == 1) {
            $('.netsuite_customers_conditional_mapping:last').prev('.requiredCM').replaceWith("<span style='float:right;' class='btn btn-danger removeCustomerCMRow'>X</span>");
        }

        $('.netsuite_customers_conditional_mapping:last').parent().find('.update_checkbox').attr('checked', false);

        $('.netsuite_customers_conditional_mapping:last').find('select').each(function () {
            $(this).val(0);
        });
    });
})(jQuery);

function processCustomerCM(cm_customer_type, cm_customer_operator, this_table) {
    var index = this_table.parent('div').data('index');
    if (this_table.find("tbody tr").length > 2 && !confirm("This action can't be undone")) {
        return false;
    }
    this_table.find("tr:gt(0)").remove();
    var template = getCustomerCMTemplate(cm_customer_type, cm_customer_operator, index);
    if (template !== false) {
        this_table.find("tbody").append(template);
    }
}

//get conditional mapping template based on type and operator
function getCustomerCMTemplate(type, operator, index) {
    var html_template = '';

    jQuery.ajax({
        url: ajaxurl,
        dataType: 'json',
        type: 'POST',
        async: false,
        data: {
            'action': 'get_conditional_mapping_template',
            'type': type,
            'operator': operator,
            'index': index
        },
        success: function (data) {
            if (data.status == 1) {
                html_template = data.template;
            }
        }
    });

    return html_template;
}

function getCustomerTypeDropdown(this_table, cm_box_index) {
    var template = '<td><span class="h5">WC Field Source</span><br/><select class="cm_customer_type input-sm" name="cm[' + cm_box_index + '][type]"><option value="0" selected>-- select field type --</option><option value="1">User Field</option><option value="2">User Meta Field</option><option value="3">Order Field</option><option value="4">Order Meta Field</option><option value="5">Gravity Form Field</option></select></td>';
    this_table.find('tbody tr').eq(0).find('td:gt(0)').remove();
    this_table.find('tbody tr').eq(0).append(template);
}

jQuery(document).ready( function($) {
	$('#getFormsPaymentFromNS').click( function() {
		var data = {
			'action': 'In8_Customer_FP',
		};

        $('#formsAndPaymentMethods').html('Loading. Please wait...');

		$.post(ajaxurl, data, function(response) {
			$('#formsAndPaymentMethods').html(response);
		});
	});
});
