<?php
	
	add_action( 'show_user_profile', 'in8_extra_user_profile_fields' );
	add_action( 'edit_user_profile', 'in8_extra_user_profile_fields' );
	
	function in8_extra_user_profile_fields( $user ) { ?>
		<h3><?php _e("In8Sync", "blank"); ?></h3>
		
		<table class="form-table">
			<tr>
				<th><label for="customerinternalid"><?php _e("Customer Internal Id"); ?></label></th>
				<td>
					<input type="text" name="customerinternalid" id="customerinternalid" value="<?php echo esc_attr( get_user_meta( $user->ID, 'customerinternalid', true ) ); ?>" class="regular-text" /><br />
                    <a href="#" class="in8SyncDeleteCustomerData" data-key="customerinternalid" data-user="<?=$user->ID?>">Delete</a>
                </td>
			</tr>
			<tr>
				<th><label for="contactinternalid"><?php _e("Contact Internal Id"); ?></label></th>
				<td>
					<input type="text" name="contactinternalid" id="contactinternalid" value="<?php echo esc_attr( get_user_meta( $user->ID, 'contactinternalid', true ) ); ?>" class="regular-text" /><br />
                    <a href="#" class="in8SyncDeleteCustomerData" data-key="contactinternalid" data-user="<?=$user->ID?>">Delete</a>
				</td>
			</tr>
		</table>

        <script>
            jQuery(function($){
                $('.in8SyncDeleteCustomerData').click(function(e){
                    e.preventDefault();
                    var $ths = $(this);
                    var type = $(this).data('key');
                    var user_id = $(this).data('user');
                    var DATA = {
                        action: 'in8sync/delete_customer_data',
                        data: type,
                        user_id: user_id,
                    }
                    $( "<span class='in8SyncDeleteCustomerDataLoading'>Loading...</span>" ).insertAfter( $ths );
                    $.post(ajaxurl, DATA, function(resp){
                        $('.in8SyncDeleteCustomerDataLoading').remove();
                        if( resp == 1 ){
                            $('#'+type).val('');
                        }else{
                            alert('Something went wrong');
                        }
                    })
                });
            })
        </script>
	<?php }
	add_action( 'personal_options_update', 'in8_save_extra_user_profile_fields' );
	add_action( 'edit_user_profile_update', 'in8_save_extra_user_profile_fields' );
	
	function in8_save_extra_user_profile_fields( $user_id ) {
		if ( !current_user_can( 'edit_user', $user_id ) ) {
			return false;
		}
		update_user_meta( $user_id, 'customerinternalid', $_POST['customerinternalid'] );
		update_user_meta( $user_id, 'contactinternalid', $_POST['contactinternalid'] );
	}
	
	add_action('wp_ajax_in8sync/delete_customer_data', function(){
	    
        if( !isset($_REQUEST['user_id']) ) die('0');
        if( !isset($_REQUEST['data']) ) die('0');
        $user_id = $_REQUEST['user_id'];
        
        if( $_REQUEST['data'] === 'customerinternalid' ){
            delete_user_meta($user_id, 'customerinternalid');
	        die('1');
        }
        if( $_REQUEST['data'] === 'contactinternalid' ){
            delete_user_meta($user_id, 'contactinternalid');
            die('1');
        }
	    
        die('0');
    });